// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.ecs20140526.*;
import com.aliyun.ecs20140526.models.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.teautil.*;
import com.aliyun.darabonbanumber.*;
import com.aliyun.teaconsole.*;
import com.aliyun.darabonba.env.*;

public class Sample {

    /**
    * Initialization  初始化公共请求参数
    */
    public static com.aliyun.ecs20140526.Client Initialization(String regionId) throws Exception {
        Config config = new Config();
        // 您的AccessKey ID
        config.accessKeyId = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID");
        // 您的AccessKey Secret
        config.accessKeySecret = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET");
        // 您的可用区ID
        config.regionId = regionId;
        return new com.aliyun.ecs20140526.Client(config);
    }

    public static Boolean IsAttachNetworkInterfaceSuccess(com.aliyun.ecs20140526.Client client, String regionId, String networkInterfaceId, Long maxDescTimes) throws Exception {
        Boolean result = false;
        Long times = 0L;
        Long step = 1L;

        while (com.aliyun.darabonbanumber.Client.lt(times, maxDescTimes)) {
            DescribeNetworkInterfacesRequest request = new DescribeNetworkInterfacesRequest()
                    .setRegionId(regionId)
                    .setNetworkInterfaceId(java.util.Arrays.asList(
                        networkInterfaceId
                    ));
            DescribeNetworkInterfacesResponse response = client.describeNetworkInterfaces(request);
            DescribeNetworkInterfacesResponseBody.DescribeNetworkInterfacesResponseBodyNetworkInterfaceSetsNetworkInterfaceSet networkInterface = response.body.networkInterfaceSets.networkInterfaceSet.get(0);
            if (com.aliyun.teautil.Common.equalString(networkInterface.status, "InUse")) {
                result = true;
                break;
            } else if (com.aliyun.teautil.Common.equalString(networkInterface.status, "Attaching")) {
                com.aliyun.teaconsole.Client.log("--------------------弹性网卡正在附加中--------------------");
            }

            times = com.aliyun.darabonbanumber.Client.add(times, step);
            com.aliyun.teautil.Common.sleep(2000);
        }
        return result;
    }

    public static void AttachNetworkInterface(com.aliyun.ecs20140526.Client client, String regionId, String networkInterfaceId, String instanceId) throws Exception {
        AttachNetworkInterfaceRequest request = new AttachNetworkInterfaceRequest()
                .setRegionId(regionId)
                .setNetworkInterfaceId(networkInterfaceId)
                .setInstanceId(instanceId);
        try {
            client.attachNetworkInterface(request);
        } catch (TeaException error) {
            com.aliyun.teaconsole.Client.log("--------------------附加弹性网卡失败:" + com.aliyun.teautil.Common.toJSONString(error.code) + "--------------------");
        } catch (Exception _error) {
            TeaException error = new TeaException(_error.getMessage(), _error);
            com.aliyun.teaconsole.Client.log("--------------------附加弹性网卡失败:" + com.aliyun.teautil.Common.toJSONString(error.code) + "--------------------");
        }        
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        // 地域Id
        String regionId = args.get(0);
        // 弹性网卡Id
        String networkInterfaceId = args.get(1);
        // ECS实例Id
        String instanceId = args.get(2);
        com.aliyun.ecs20140526.Client client = Sample.Initialization(regionId);
        // 附加弹性网卡
        Sample.AttachNetworkInterface(client, regionId, networkInterfaceId, instanceId);
        Long maxDescTimes = 10L;
        Boolean ret = Sample.IsAttachNetworkInterfaceSuccess(client, regionId, networkInterfaceId, maxDescTimes);
        if (ret) {
            com.aliyun.teaconsole.Client.log("--------------------附加弹性网卡成功--------------------");
        } else {
            com.aliyun.teaconsole.Client.log("--------------------附加弹性网卡失败--------------------");
        }

    }
}
